/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * Warning! This file is generated. Modify at your own risk.
 */

package com.google.api.services.admin.model;

import com.google.api.client.json.GenericJson;

/**
 * JSON template for MailItem object in Email Migration API.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Email Migration API v2. For a detailed explanation
 * see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * <p>
 * Upgrade warning: starting with version 1.12 {@code getResponseHeaders()} is removed, instead use
 * {@link com.google.api.client.http.json.JsonHttpRequest#getLastResponseHeaders()}
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class MailItem extends GenericJson {

  /**
   * Boolean indicating if the mail is deleted (used in Vault)
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Boolean isDeleted;

  /**
   * Boolean indicating if the mail is draft
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Boolean isDraft;

  /**
   * Boolean indicating if the mail is in inbox
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Boolean isInbox;

  /**
   * Boolean indicating if the mail is in 'sent mails'
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Boolean isSent;

  /**
   * Boolean indicating if the mail is starred
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Boolean isStarred;

  /**
   * Boolean indicating if the mail is in trash
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Boolean isTrash;

  /**
   * Boolean indicating if the mail is unread
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Boolean isUnread;

  /**
   * Kind of resource this is.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String kind;

  /**
   * List of labels (strings)
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<String> labels;

  /**
   * Boolean indicating if the mail is deleted (used in Vault)
   * The value returned may be {@code null}.
   */
  public Boolean getIsDeleted() {
    return isDeleted;
  }

  /**
   * Boolean indicating if the mail is deleted (used in Vault)
   * The value set may be {@code null}.
   */
  public MailItem setIsDeleted(Boolean isDeleted) {
    this.isDeleted = isDeleted;
    return this;
  }

  /**
   * Boolean indicating if the mail is draft
   * The value returned may be {@code null}.
   */
  public Boolean getIsDraft() {
    return isDraft;
  }

  /**
   * Boolean indicating if the mail is draft
   * The value set may be {@code null}.
   */
  public MailItem setIsDraft(Boolean isDraft) {
    this.isDraft = isDraft;
    return this;
  }

  /**
   * Boolean indicating if the mail is in inbox
   * The value returned may be {@code null}.
   */
  public Boolean getIsInbox() {
    return isInbox;
  }

  /**
   * Boolean indicating if the mail is in inbox
   * The value set may be {@code null}.
   */
  public MailItem setIsInbox(Boolean isInbox) {
    this.isInbox = isInbox;
    return this;
  }

  /**
   * Boolean indicating if the mail is in 'sent mails'
   * The value returned may be {@code null}.
   */
  public Boolean getIsSent() {
    return isSent;
  }

  /**
   * Boolean indicating if the mail is in 'sent mails'
   * The value set may be {@code null}.
   */
  public MailItem setIsSent(Boolean isSent) {
    this.isSent = isSent;
    return this;
  }

  /**
   * Boolean indicating if the mail is starred
   * The value returned may be {@code null}.
   */
  public Boolean getIsStarred() {
    return isStarred;
  }

  /**
   * Boolean indicating if the mail is starred
   * The value set may be {@code null}.
   */
  public MailItem setIsStarred(Boolean isStarred) {
    this.isStarred = isStarred;
    return this;
  }

  /**
   * Boolean indicating if the mail is in trash
   * The value returned may be {@code null}.
   */
  public Boolean getIsTrash() {
    return isTrash;
  }

  /**
   * Boolean indicating if the mail is in trash
   * The value set may be {@code null}.
   */
  public MailItem setIsTrash(Boolean isTrash) {
    this.isTrash = isTrash;
    return this;
  }

  /**
   * Boolean indicating if the mail is unread
   * The value returned may be {@code null}.
   */
  public Boolean getIsUnread() {
    return isUnread;
  }

  /**
   * Boolean indicating if the mail is unread
   * The value set may be {@code null}.
   */
  public MailItem setIsUnread(Boolean isUnread) {
    this.isUnread = isUnread;
    return this;
  }

  /**
   * Kind of resource this is.
   * The value returned may be {@code null}.
   */
  public String getKind() {
    return kind;
  }

  /**
   * Kind of resource this is.
   * The value set may be {@code null}.
   */
  public MailItem setKind(String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * List of labels (strings)
   * The value returned may be {@code null}.
   */
  public java.util.List<String> getLabels() {
    return labels;
  }

  /**
   * List of labels (strings)
   * The value set may be {@code null}.
   */
  public MailItem setLabels(java.util.List<String> labels) {
    this.labels = labels;
    return this;
  }

}
